> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://mailchimp.com/developer/marketing/api/campaigns/upsert-content/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://mailchimp.com/_mcp/server.
# Set campaign content
PUT https://api.mailchimp.com/3.0/campaigns/{campaign_id}/content
Content-Type: application/json
Set the content for a campaign.
Reference: https://mailchimp.com/developer/marketing/api/campaigns/upsert-content
## Authentication
- `Authorization` header (bearer token, required) — Authorization using a Mailchimp API key (a.k.a. Bearer token)
- `Authorization` header (bearer token, required) — Authorization using OAuth
## Request
### Path parameters
- `campaign_id` (string, required) — The unique id for the campaign.
### Body (application/json)
This endpoint expects a CampaignContent.
- `_links` (list of CampaignContentLinksItems, optional) — A list of link types and descriptions for the API schema documents.
- `archive_html` (string, optional) — The Archive HTML for the campaign.
- `html` (string, optional) — The raw HTML for the campaign.
- `plain_text` (string, optional) — The plain-text portion of the campaign. If left unspecified, we'll generate this automatically.
- `variate_contents` (list of CampaignContentVariateContentsItems, optional) — Content options for multivariate campaigns.
## Response
### 200
- `_links` (list of CampaignContentLinksItems, optional) — A list of link types and descriptions for the API schema documents.
- `archive_html` (string, optional) — The Archive HTML for the campaign.
- `html` (string, optional) — The raw HTML for the campaign.
- `plain_text` (string, optional) — The plain-text portion of the campaign. If left unspecified, we'll generate this automatically.
- `variate_contents` (list of CampaignContentVariateContentsItems, optional) — Content options for multivariate campaigns.
## Types
### CampaignContentLinksItems
This object represents a link from the resource where it is found to another resource or action that may be performed.
- `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action.
- `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'.
- Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD`
- `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link.
- `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to.
- `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to.
### CampaignContentVariateContentsItems
- `content_label` (string, optional) — Label used to identify the content option.
- `html` (string, optional) — The raw HTML for the campaign.
- `plain_text` (string, optional) — The plain-text portion of the campaign. If left unspecified, we'll generate this automatically.
## Examples
**Request**
```json
{}
```
**Response**
```json
{
"_links": [
{
"href": "string",
"method": "GET",
"rel": "string",
"schema": "string",
"targetSchema": "string"
}
],
"archive_html": "
My Subject",
"html": "string",
"plain_text": "string",
"variate_contents": [
{
"content_label": "Green header",
"html": "*|MC:SUBJECT|*",
"plain_text": "string"
}
]
}
```
**SDK Code**
```python
import requests
url = "https://api.mailchimp.com/3.0/campaigns/campaign_id/content"
payload = {}
headers = {
"Authorization": "Bearer ",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.json())
```
```javascript
const url = 'https://api.mailchimp.com/3.0/campaigns/campaign_id/content';
const options = {
method: 'PUT',
headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'},
body: '{}'
};
try {
const response = await fetch(url, options);
const data = await response.json();
console.log(data);
} catch (error) {
console.error(error);
}
```
```go
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.mailchimp.com/3.0/campaigns/campaign_id/content"
payload := strings.NewReader("{}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer ")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(res)
fmt.Println(string(body))
}
```
```ruby
require 'uri'
require 'net/http'
url = URI("https://api.mailchimp.com/3.0/campaigns/campaign_id/content")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer '
request["Content-Type"] = 'application/json'
request.body = "{}"
response = http.request(request)
puts response.read_body
```
```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;
HttpResponse response = Unirest.put("https://api.mailchimp.com/3.0/campaigns/campaign_id/content")
.header("Authorization", "Bearer ")
.header("Content-Type", "application/json")
.body("{}")
.asString();
```
```php
request('PUT', 'https://api.mailchimp.com/3.0/campaigns/campaign_id/content', [
'body' => '{}',
'headers' => [
'Authorization' => 'Bearer ',
'Content-Type' => 'application/json',
],
]);
echo $response->getBody();
```
```csharp
using RestSharp;
var client = new RestClient("https://api.mailchimp.com/3.0/campaigns/campaign_id/content");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer ");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```
```swift
import Foundation
let headers = [
"Authorization": "Bearer ",
"Content-Type": "application/json"
]
let parameters = [] as [String : Any]
let postData = JSONSerialization.data(withJSONObject: parameters, options: [])
let request = NSMutableURLRequest(url: NSURL(string: "https://api.mailchimp.com/3.0/campaigns/campaign_id/content")! as URL,
cachePolicy: .useProtocolCachePolicy,
timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data
let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
if (error != nil) {
print(error as Any)
} else {
let httpResponse = response as? HTTPURLResponse
print(httpResponse)
}
})
dataTask.resume()
```
> Find all the Mailchimp API documentation and tools developers need to send marketing and transactional emails.